{                                                                    }
{   Copyright  1998 by Mik                                          }
{                                                                    }
{ ****************************************************************** }

unit Mydict;

interface

uses WinTypes, WinProcs, Messages, SysUtils, Classes, Controls,
     Dialogs;
const
	max_buffer = 2000;
type
TFILEOBJ = object
       f : file; {file pointer}
       keylen : byte; {len of key *}
       BUFSIZE : WORD; {len of record *}
       CODE : Integer;  {no actual use but validate reading}
       MAXINDEX : LONGINT; {max record in file}
       valid : boolean; {indicate file ok to process}
       indexrec : ARRAY[0..max_buffer] OF CHAR; {buffer}
       procedure  set_key_len(n : Byte); {set len of search key *}
       procedure openfile(FNAME : String; BUFLEN : Word);
       function find(key : String) : LongInt;
       function GETFIRST(key : String) : LongInt;
       function get_key:string;  {returns key *}
       procedure get_block_data(pos: longint);
       procedure getdata(pos: longint;var x);
       procedure putdata(pos: longint;var x);
       procedure CLOSEALL;
       PROCEDURE FLUSH(VAR M); {to move buffer to var *}
     end;

  TDictn = class(Tcomponent)
    private
      { Private fields of Tdictn }
      Mdict :TFILEOBJ;
      { Private methods of Tdictn }
        { Method to set variable and property values and create objects }
        procedure AutoInitialize;
        { Method to free any objects created by AutoInitialize }
        procedure AutoDestroy;

    protected
      { Protected fields of Tdictn }

      { Protected methods of Tdictn }
        procedure Loaded; override;

    public
      { Public fields of Tdictn }

      { Public methods of Tdictn }
        constructor Create(AOwner: TComponent); override;
        destructor Destroy; override;
        function SpellCheck(key:string):boolean;

    published
      { Published properties of the component }

  end;

procedure Register;
function Trim (S: string): string;
implementation


{variable rec size object searching
usage :
openfile(filename, rec size)
set_key_len(len);
find(key : string20 max) return pos > 0;
then data is store in INDEXREC that get_key will extract key from.
for sequencial read, use get_block_data(pos);
closeall after used.
* note no virtual method implemented.
}


function Trim (S: string): string;
var
  ii: byte;
begin
   ii := 1;
   While (Length (S) >= ii) and
         (S [ii] = ' ') do
         inc (ii);
   S := copy (S, ii, 255);
   ii := Length (S);
   If ii = 0 then begin
      Trim := '';
      exit;
   end;
   While (S [ii] = ' ') and (ii > 0) do
         dec (ii);
   if ii > 0 then
    Trim := copy (S, 1, ii)
   else
    trim := '';
end;

  function PadCh(S : string; Ch : Char; Len : Byte) : string;
    {-Return a string right-padded to length len with ch}
  var
    o : string;
    SLen : Byte absolute S;
  begin
    if Length(S) >= Len then
      PadCh := S
    else begin
      o[0] := Chr(Len);
      Move(S[1], o[1], SLen); {!!.01}
      if SLen < 255 then
        FillChar(o[Succ(SLen)], Len-SLen, Ch);
      PadCh := o;
    end;
  end;

  function Pad(S : string; Len : Byte) : string;
    {-Return a string right-padded to length len with blanks}
  begin
    Pad := PadCh(S, ' ', Len);
  end;

procedure TFILEOBJ.putdata(pos: longint;var x);
begin
	if not valid then exit;
	seek(f,pos);
	Blockwrite(f, x, 1, CODE);
end;

function TFILEOBJ.get_key:string;
var
	tmp : string;
begin
	get_key := '';
	if keylen = 0 then exit;
	move(indexrec,tmp,keylen+1);
	tmp[0] :=char(keylen);
	get_key := tmp;
end;

function TFILEOBJ.GETFIRST(key : String) : LongInt;
VAR
	M : BYTE;
	N: LONGINT;
BEGIN
	GETFIRST := 0;
	if not valid then exit;
	M:= KEYLEN;
	set_key_len(LENGTH(KEY));
	N:= FIND(KEY);
	set_key_len(M);
	IF N > 0 THEN GETFIRST := N;
END;

procedure TFILEOBJ.getdata(pos: longint;var x);
begin
	if not valid then exit;
	IF POS <= MAXINDEX THEN
		begin
			seek(f,pos);
			BlockRead(f, indexrec, 1, CODE);
		end
	else
		fillchar(indexrec,max_buffer,#0);
	FLUSH(X);
end;

procedure TFILEOBJ.get_block_data(pos: longint);
begin
	if not valid then exit;
	IF POS <= MAXINDEX THEN
		begin
			seek(f,pos);
			BlockRead(f, indexrec, 1, CODE);
		end
	else
		fillchar(indexrec,max_buffer,#0);
end;

PROCEDURE TFILEOBJ.FLUSH(VAR M);
BEGIN
	MOVE(INDEXREC,M,BUFSIZE);
END;

procedure TFILEOBJ.  set_key_len(n : Byte);
begin
	keylen := n;
end;

procedure TFILEOBJ.CLOSEALL;
begin
	{$i-}
		Close(f);
	{$i+}
	if ioresult <> 0 then;
end;

procedure TFILEOBJ.openfile;
begin
	valid := true;
	Assign(f, FNAME);
	{$i-}
	Reset(f, BUFLEN);
	{$i+}
	if ioresult <> 0 then
		begin
			valid := false;
			exit;
		end;
	BUFSIZE :=BUFLEN;
	KEYLEN := 5;
	MAXINDEX := FILESIZE(F) -1;
end;

function TFILEOBJ.find;
var
	High, Low,
	mid : LongInt;
	strr : String;
	i: WORD;
begin
	find := -1;
	if not valid then exit;
	key := trim(key);
	if key = '' then Exit;
	Low := 0;
	High := MAXINDEX;
	key := pad(key,keylen);
	key :=  Uppercase(key);
	while (Low <= High) do
		begin
			mid := (High+Low) div 2;
			Seek(f, mid);
			BlockRead(f, indexrec, 1, CODE);
			if code <> 1 then exit;
			MOVE(indexrec,STRR, Length(key) + 1);
			STRR := pad(trim(STRR),keylen);
			IF LENGTH(STRR) > KEYLEN THEN
			STRR[0] := CHAR(KEYLEN);
			strr :=  Uppercase(strr);
			if (strr = key) then
				begin
					for i := mid downto 0 do
						begin
							Seek(f, I);
							BlockRead(f, indexrec, 1, CODE);
							MOVE(indexrec,STRR, Length(key) + 1);
							STRR := pad(trim(STRR),keylen);
							IF LENGTH(STRR) > KEYLEN THEN
								STRR[0] := CHAR(KEYLEN);
							strr :=  Uppercase(strr);
							if (strr <> key) then
								begin
									mid := i + 1;
									Seek(f, mid);
									BlockRead(f, indexrec, 1, CODE);
									break;
								end
							ELSE
							IF I = 0 THEN
								BEGIN
									IF (strr = KEY) THEN
										MID := I + 1
									ELSE
										MID := I;
								END;
						end;{for}
					find := mid;
					Break;
				end
			else
			if (strr > key) then
				High := mid-1
			else
				Low := mid+1;
		end;{while}
end;



procedure Register;
begin
     { Register Tdictn with Dialogs as its
       default page on the Delphi component palette }
     RegisterComponents('Custom', [Tdictn]);
end;

{ Method to set variable and property values and create objects }
procedure Tdictn.AutoInitialize;
begin
 Mdict.openfile('english.dic',31);
 if not Mdict.valid then
  showmessage('English.dic dictionary not found!');
end; { of AutoInitialize }

{ Method to free any objects created by AutoInitialize }
procedure Tdictn.AutoDestroy;
begin
     { No objects from AutoInitialize to free }
  Mdict.closeall;
end; { of AutoDestroy }

constructor Tdictn.Create(AOwner: TComponent);
begin
     { Call the Create method of the parent class }
     inherited Create(AOwner);

     { AutoInitialize sets the initial values of variables and      }
     { properties; also, it creates objects for properties of       }
     { standard Delphi object types (e.g., TFont, TTimer,           }
     { TPicture) and for any variables marked as objects.           }
     { AutoInitialize method is generated by Component Create.      }
     AutoInitialize;

     { Code to perform other tasks when the component is created }

end;

destructor Tdictn.Destroy;
begin
     { AutoDestroy, which is generated by Component Create, frees any   }
     { objects created by AutoInitialize.                               }
     AutoDestroy;

     { Here, free any other dynamic objects that the component methods  }
     { created but have not yet freed.  Also perform any other clean-up }
     { operations needed before the component is destroyed.             }

     { Last, free the component by calling the Destroy method of the    }
     { parent class.                                                    }
     inherited Destroy;
end;

procedure Tdictn.Loaded;
begin
     inherited Loaded;

     { Perform any component setup that depends on the property
       values having been set }

end;

function Tdictn.SpellCheck(key:string):boolean;
begin
    SpellCheck := mdict.find(key) > 0;
end;

begin
  FileMode := 66;                 {NETWORK SHARE READ WRITE}
end.
